;; A.- Funciones aritmeticas entre VECTORES
;;a.1. CON RESULTADO VECTORIAL

;; ALTERANDO ARGUMENTOS

;este procedimiento devuelve el primer argumento alterado!!
(define (vector-for-each procedure x)
(##declare (fixnum n i))
  (let ((n (vector-length x)))
    (do ((i 0 (+ 1 i)))
        ((= i n) x)
      (vector-set! x i (procedure (vector-ref x i))))))

;este procedimiento devuelve el primer argumento alterado!!
(define (vector-mfor-each procedure . x)
(##declare (fixnum n i))
  (let ((n (vector-length (car x))))
    (do ((i 0 (+ 1 i)))
        ((= i n) (car x))
      (vector-set! (car x) i
              (apply procedure (map (lambda(z)(vector-ref z i)) x))))))
 

;; DEVOLVIENDO UN VECTOR NUEVO

;; clonando un vector

(define (vector-clone v)
  (let ((xx (make-vector (vector-length v))))
    (for i 0 (- (vector-length xx) 1) (-> xx i (<- v i)))
    xx))

;; suma una constante a todo el vector
(define (kplus x k)
(##declare (fixnum n i))
   (if (vector? x)
     (let* 
       ((n (vector-length x))
        (y (make-vector n 0)))
       (do ((i 0  (+ i 1)))
           ((= i n) y)
         (vector-set! y i (+ (vector-ref x i) k))))
     (+ x k)))

;; suma varios vectores
(define (aplus . x)
(##declare (fixnum n i))
  (if (vector? (car x))
    (let* 
      ((n (vector-length (car x)))
       (z (make-vector n 0)))
      (do
        ((i 0 (+ i 1)))
        (( = i n) z)
        (vector-set! z i (apply + (map (lambda(x)(vector-ref x i)) x)))))
    (apply + x)))

;; multiplica un vector por un nmero
(define (atimesk k x)
(##declare (fixnum n i))
  (if (vector? x)
    (let* 
      ((n (vector-length x))
       (z (make-vector n 0)))
      (do
        ((i 0 (+ i 1)))
        (( = i n) z)
        (vector-set! z i (* (vector-ref x i) k))))
    (* k x)))

;; especial para vectores de variables estadisticas.
(define (vector-take vars x t)
(##declare (fixnum n i))
  (let ((n (vector-length vars)))
    (do ((i 0 (+ i 1)))
        ((= i n) #t)
      (take (vector-ref vars i) (make-point t (vector-ref x i))))))


;;; a.1.- CON RESULTADO ESCALAR

; suma todos los elementos de un vector
(define (suma x)
(##declare (fixnum n i))
  (let ((n (vector-length x)))
    (do ((i 0 (+ 1 i))
         (sum 0 (+ sum (vector-ref x i))))
        ((= i n) sum))))

; producto escalar de dos vectores
(define (inner x y)
(##declare (fixnum n i))
  (if (vector? x)
    (let
      ((sum 0)
       (n (vector-length x)))
      (do ((i 0 (+ 1 i))
           (sum 0 (+ sum (* (vector-ref  x i)(vector-ref y i)))))
          ((= i n) sum)))
    (* x y)))


;; b.- LISTAS

; multiplica una lista por un nmero
(define (timesk k x)
  (map (lambda(w)(* k w)) x))
