
;;A very general object that has a name, can be traced and can ask questions
;; Traces can be customized by redefining the show method, which is the
;; default meroon method. If you want to display an object use display-object
;;Oracle is a place (list of) where questions may be asked.

;;------------------------------------------------------------------------
(define-class named-object Object 
                           ((= name :maybe-uninitialized)
                            (= trace  :initializer (lambda()#f))
                            (= stoped :initializer (lambda()#f))))


; some very generic generics

(define-generic (trace-on  (uNO Named-Object) . others) 
                (Set-Named-Object-trace! uNO #t)
                (for-each (lambda(x)(Set-Named-Object-trace! x #t)) others)
                #t)
(define-generic (trace-off (uNO Named-Object) . others) 
                (Set-Named-Object-trace! uNO #f)                
                (for-each (lambda(x)(Set-Named-Object-trace! x #f)) others)
                #f)
(define-generic (start-object-process (aN named-object) t0 . args))
(define-generic (stop-object (uNO Named-Object))
                (set-named-object-stoped! uNO #t))
(define-generic (start-object (uNO Named-Object))
                (set-named-object-stoped! uNO #f))

;Now we have objects  with  keys therefore redefine the default key to return 
;the name as the key.

(define-method (object-key (aNO named-object))
     (named-object-name aNO))

;; Redefine the show method to avoid circular printing of objects.
(define-method (show (unOb Named-Object) . stream)
     (display (named-object-name unob))
     (call-next-method))

;; functions to turn traces on and off, for lists of elements.
(define (trace-objects . list)
  (for-each (lambda(x)(trace-on x)) list))
(define (untrace-objects . list)
  (for-each (lambda(x)(trace-off x)) list)) 

   