
(require 'heaps)
;
;---------------------------------------------------------------------
;;priority queues
;; they are a subclass of heap. The heap is built out of any objects.
;; either a numeric key is defined or a method object<? is provided 
;;FIFO is a function that implements FIFO priority

(define (make-FIFO)
  (let
    ((prior 0))
    (lambda()(set! prior (+ 1 prior)) prior)))

(define FIFO (make-fifo))
;----------------------------------------------------------------------
;; uses the key field (in heaps) to specify the waiting order

(define-class priority-queue heap ())

(define-method (put! (as Priority-queue) arg)
   (if (call-next-method) #t
       (begin
         (expand-heap as)
         (call-next-method))))

(define-method (empty? (as priority-queue))
    (zero? (heap-n as)))

;;---------------------------------------------------------------------------

;; STAT-PRIORITY-QUEUES
;; as always if you want other types of statistics, replace the number slot
;; with the desired type of statistical variable.

(define-class stat-priority-queue priority-Queue
        ((= number :inmutable :maybe-uninitialized)))

(define-method (initialize! (aSPQ stat-priority-queue))
    (call-next-method)
    (init-stats-gatherer! aSPQ
           (Instantiate Time-var :name (qualify-name aSPQ "stats"))
           'number)
    aSPQ)

(define-handy-method (put! (q Stat-priority-queue) arg)
   (increment number (current-time))
   (call-next-method))
 

(define-handy-method (get! (q Stat-priority-queue))
    (let
      ((x (call-next-method)))
      (if x (decrement number (current-time)))
      x))

(define-handy-method (display-object (q stat-priority-Queue) . stream)
   (displayLine "Statistics for queue " name)
   (display-object number)) 
