;;; Set this to #t if you want the toolboxes to be available for requiring

;; Loading the SIMMER System
;;====================================================================
;this file should be in the starting folder for MacGambit

(load (pathname ":SimmerV1.01:SimmerOptions"))
(load (pathname ":SimmerV1.01:SimmerSources:simmerInit.scm"))
(load (pathname ":SimmerV1.01:SimmerSources:MeroonUtilities.scm"))

;==================LOADING THE SIMULATOR===============================
(define *directories* 
  (list (list 'dir1 simul-path)
        (list 'dir2 toolboxes-path)))

(define *index* 
  '((meroon-utilities  (dir1 MeroonUtilities))
    (SlibHash          (dir1 SlibHash))
    (distributions     (dir1 SimMerDistributions))
    (named-objects     (dir1 SimMerNamed-Object))
    (collections       (dir1 SimMerCollection))
    (heaps             (dir1 SimMerHeap))
    (stat-vars         (dir1 SimMerStat-Vars))
    (queues            (dir1 SimMerQueue))
    (priority-Queues   (dir1 SimMerPriorQueues))
    (Files             (dir1 SimMerFiles))
    (sets              (dir1 SimMerSets))
    (procesos          (dir1 SimMerExtraControls))
    (monitors          (dir1 SimMerMonitors))
    (channels          (dir1 SimmerChannels))
    (mail-boxes        (dir1 SimmerMail-boxes))
    (supervisors       (dir1 SimMerSupervisors))
    (blocks            (dir1 SimMerBlocks))
    (some-blocks       (dir1 SimMerSomeBlocks))
    (windows           (dir1 SimmerWindows))
    (menus             (dir1 SimmerMenus))
    (graphics          (dir1 SimmerDrawing))
    (histograms        (dir1 SimmerHistograms))
    (graph-vars        (dir1 SimmerGraphVars))
    (points            (dir1 SimmerPoints))
    (time-functions    (dir1 SimmerTimeFuncs))
    (dynamic-graphs    (dir1 SimmerDynamicGraphs))
    (registered-classes(dir1 SimmerRegClasses))
    (diff-equations    (dir1 DExtIntegrating))
    (gdiff-equations   (dir1 DExtGraphicDObj))
    (vector-arithmetic (dir1 DExtVectorArithmetic))))

    (set! *index* (append *index* 
                          (if *high-speed-version* 
                            (begin
                             '((simulation        (dir1 $imMerControl))
                               (events            (dir1 $immerEvents))))
                            (begin
                              '((simulation        (dir1 SimMerControl))
                                (events            (dir1 SimmerEvents)))))))

;;; This is only if you use the Toolboxes

(define *index-Tools*
  '((systems           (dir2 TLB.systems))
    (patterns          (dir2 jr.patterns))
    (Knowledge-Bases   (dir2 TLB.KnowledgeBases))
    (productions       (dir2 TLB.Productions))
    (associative-networks (dir2 TLB.AssociativeNetworks))
    (frames            (dir2 TLB.Frames))
    (atns              (dir2 TLB.ATNs))))

(if *tool-boxes-available* (set! *index* (append *index* *index-tools*)))