(define (pathname xx)
  (string-append mac#home-folder xx))

;; finds a symbol
(define (find-symbol-in-files symbol0 path namelist terminacion)
  (let ((nom ""))
  (define (rec-member b)
    (cond ((pair? b) (or (rec-member (car b))(rec-member (cdr b))))
          ((not (null? b))(equal? symbol0 b))
          (else #f)))
  (define (find-in-file)
    (let ((x (read)))
      (if (not (eof-object? x))
         (begin
           (if (rec-member x) (displayLine nom "..." (car x) (cadr x)))
           (find-in-file))
         #f)))
  (displayLine "Finding: " symbol0)
  (let loop ((nombres namelist))
    (if (pair? nombres)
      (begin
       (set! nom (symbol->string (car nombres)))
       (with-input-from-file (string-append path nom terminacion )
                             (lambda()(find-in-file)))
       (loop (cdr nombres)))))))


;; finds a pattern, using the syntax of the ToolBoxes . 
;; If you want to use this function you have to load 
;; (pathname ":toolboxes:JRPatterns.scm")

(define (find-pattern-in-files pattern path namelist terminacion)
  (let ((nom ""))
    (define (find-in-file)
      (let ((x (read)))
        (if (not (eof-object? x))
          (begin
           (if (match pattern x) (displayLine nom "..." (car x) (cadr x)))
           (find-in-file))
          #f)))
    (displayLine "Finding: " pattern)
    (let loop ((nombres namelist))
      (if (not (null? nombres))
        (begin
         (set! nom (symbol->string (if (pair? nombres) (car nombres) nombres))) 
         (with-input-from-file (string-append path nom terminacion )
                               (lambda()(find-in-file)))
         (if (pair? nombres) (loop (cdr nombres))))))))


;;finds a pattern and substitutes it by using the ToolBoxes JRPatterns function
;; makevariablesubst

(define (substitute-in-files pattern0 pattern1 path namelist)
  (define (substitute-in-file)
    (let loop ((x (read)))
      (if (not (eof-object? x))
        (begin
         (let ((theAlist (match pattern0 x)))
          (if theAlist (write (makeVariableSubst pattern1 theAlist))
              (write x)))
          (loop (read))))
        #f))

  (let loop ((nombres namelist))
    (if (pair? nombres)
      (begin
        (let* ((nomin (symbol->string (car nombres)))
              (nomout (string-append nomin ".out")))
          (display (string-append "***Substituting in:" nomin))
          (with-input-from-file (string-append path nomin)
               (lambda()
                 (with-output-to-file (string-append path nomout)
                      (lambda()(substitute-in-file)))))
          (newline)
          (loop (cdr nombres)))))))



