;;; Uncomment the following line if you are not using a compiled version
;(require 'simulation)
;----------------------------------------------------------------- 

;; a simple elementary test to be run as the first test.
;;it does not do anything. Just writes a few messages.

;;; 0) Defining classes

(define-class interruptible named-object ())
(define-class volunteer interruptible (time))
(define-class item volunteer (n))


(define-generic (action (aI interruptible)))

;;; 1) Define the operating processes
(define-async-method (action (aI item)) 
   (let loop ((n (item-n aI)))
     (if (> n 0)
       (begin
        (displayLine "I am the item " (Item-name aI) (item-n aI))
        (action (instantiate item :name "second" :n (- n 1) :time 3))
        (action (instantiate item :name "third"  :n (- n 1) :time 10))
        (wait-duration (item-time aI))
        (DisplayLine "Time " (current-Time) 
                     (item-name aI) " continuing. I have created " n)
        (loop (- n 1))))))


(define-async-method (action (aV volunteer)) 
   (let loop ((i 1))
     (displayLine "Here a volunteer" i " Time " (current-time))
     (wait-duration (volunteer-time aV))
     (if (< i 10) (loop (+ i 1)))))

(define-async-method (action (aI interruptible) )
   (let loop ((i 1))
     (displayLine (interruptible-name aI) " at time " (current-time))
     (reschedule)
     (if (< i 5) (loop (+ 1 i)))))


;; 2) Initialization
(init-simulation)
(define vol (instantiate volunteer :name "Volunteer" :time 5))
(define first (instantiate item :time 2 :name "First" :n 3))
(define interruptible-1 (instantiate interruptible :name "interruptible-1"))
(define interruptible-2 (instantiate interruptible :name "interruptible-2")) 
(action first)
(action vol)
(action interruptible-1)
(action interruptible-2)


;; 4) Define events  
(create-event 15 stop)
(trace-off *overlord*)
;; 5) Start Simulation
(start-simulation)


;;========================================================
;I am the item  First 3 
;Here a volunteer 1  Time  0. 
;interruptible-1  at time  0. 
;interruptible-2  at time  0. 
;I am the item  second 2 
;I am the item  third 2 
;interruptible-1  at time  0. 
;interruptible-2  at time  0. 
;I am the item  second 1 
;I am the item  third 1 
;I am the item  second 1 
;I am the item  third 1 
;interruptible-1  at time  0. 
;interruptible-2  at time  0. 
;interruptible-1  at time  0. 
;interruptible-2  at time  0. 
;interruptible-1  at time  0. 
;interruptible-2  at time  0. 
;Time  2. First  continuing. I have created  3 
;I am the item  First 3 
;I am the item  second 1 
;I am the item  third 1 
;Time  3. second  continuing. I have created  2 
;I am the item  second 2 
;Time  3. second  continuing. I have created  1 
;Time  3. second  continuing. I have created  1 
;Time  4. First  continuing. I have created  2 
;I am the item  First 3 
;Time  5. second  continuing. I have created  1 
;Here a volunteer 2  Time  5. 
;Time  6. First  continuing. I have created  1 
;Time  6. second  continuing. I have created  1 
;Time  10. third  continuing. I have created  1 
;Here a volunteer 3  Time  10. 
;Time  10. third  continuing. I have created  2 
;I am the item  third 2 
;Time  10. third  continuing. I have created  1 
;Time  12. third  continuing. I have created  1 
;end!!!