;;; Uncomment the following line if you are not using a compiled version

; (require 'monitors)

;;; a test of using resources, modeled as facilities.
;;;
;;; The basic items than want to gain control to the resources of facility
;;;
(define-class item named-object ((= stay :maybe-uninitialized)))
;;;
;;; The generic and method providing the life story of an item.
;;;
(define-generic (life-path (anI item) f1))

(define-async-method(life-path (anI item) f1)
  (let loop ()
    (displayline (item-name anI) ": I and would like to enter the facility")
    (enter f1)
    (displayLine (item-name anI) "entering in facility at: " (current-time))
    (wait-duration (item-stay anI))
    (displayLine (item-name anI) " leaving facility at: " (current-time))
    (leave f1)
    (displayLine )
    (loop)))
;;;-------------------------------------------------------------------------
;;; Now simulate
;;;-------------------------------------------------------------------------

(let ((p1 (instantiate item :name 'p1 :stay 10))
      (p2 (instantiate item :name 'p2 :stay 20))
      (f1 (instantiate facility 
               :max-number 1 
               :parking-place  
               (instantiate queue ))))
  (init-simulation)
  (generic-untrace 'take )
  (create-event 100 stop)
  (life-path p1 f1)
  (life-path p2 f1)
  (start-simulation)
  (display-object (facility-parking-place f1)))

;;==================Gathering statistics==================================

;a) Collecting statistics.
;Try defining the facility as

(define f1 (instantiate facility :parking-place  (instantiate stat-queue)))

; now perform the simulation, as before (nothing should change!!!!)

; b) Now try 
(define f1 (instantiate facility 
     :parking-place  (instantiate stat-queue :number (instantiate step-var))))
;; Do you unserstand the reason for the result?. Try using a gtime-var.
;; do you see the shape?
;; Now you see the reason for these variables. In the previous case you got 
;; and average number in service of .5, but the server was busy all the time!!!.
;; This is due to the nature of tiem variables as data collecting devices.
;; They assume a continuous function unless told otherwise. But the sample
;; path in this case is discontinuos. Also que server empties and fills in 
;; the same instant of time. You get an observationof 0 and then another of
;; 1 for the number in system. Since the time functio interpolates linearly
;; the sample path is a saw teeth shape, and therefore the result makes sense.

; c) Collecting graphical statistics
;(require 'graph-vars)
(define f1 (instantiate facility 
     :parking-place  (instantiate stat-queue :number (instantiate stime-var))))

; and do the same as before

