
;;; Uncomment the following 2 lines if you are not using a compiled version
;(require 'distributions)
;(require 'channels)

; A server serves messages and an eater eats them according to a
; probability distribution. Notice that channels have stat-queues since
; usually we are interested in knowing what happens.
; Notice that we are using the channel itself as message bearer. This is no
; problem because there is only one message bearer. It would not work in
; more general cases and can be considered "tricky"

(define-class my-message object ((* attributes)))

(define-class message-processor channel
              ((= message :initializer (lambda()#f))
               (= wait-sending :initializer (lambda()#f))
               (= wait-receiving :initializer (lambda()#f))))

(define-generic (feed (aM message-processor)))

(define-generic (eat (aM message-processor)))

(define-async-method (feed (aM message-processor)) 
  (let loop  ((unaTrans (make-my-message 1 (current-time)))
              (i 0))
    (display "Feed method ")
    (displayLine " Serving " (format (current-time) 3) unaTrans)
    (take aM unaTrans)
    (wait-duration (sample (message-processor-wait-sending aM)))
    (if (< i 5) (loop (make-my-message 1 (current-time)) (+ i 1)))))

(define-async-method (eat (aM  message-processor)) 
  (let loop
    ((i 0))
    (display "Eat method ")
    (displayLine " Trying to eat " i (format (current-time) 3))
    (let (( resultado (give aM)))
      (displayLine " eating " (format (current-time) 3) resultado)
      (wait-duration (sample (message-processor-wait-receiving aM)))
      (if (< i 5) (loop (+ i 1))))))


(define-method (show (aQ queue) . st)
   (displayLine "Una cola " (empty? aQ))
   (for-each-elt aQ displayLine))

(define-method (show (aC message-processor) . st)
   (show (message-processor-message-list aC))
   (show (message-processor-queue aC)))

(define-method (show (aM my-message) . st)
   (display "Un Mensaje ")
   (for i 0 (- (my-message-attributes-length aM) 1)
        (display (my-message-attributes aM i))))

(init-simulation)
(set! *random* (make-random))
(define station (instantiate message-processor 
                             :wait-sending (make-exponential 3)
                             :wait-receiving (make-exponential 2)))
(create-event 15 stop)
(feed station)
(eat station)
(start-simulation)
(display-object station)