;;; Uncomment the following line if you are not using a compiled version
; (require 'monitors)

;; ******* TEST OF CONDITIONS****************************************
;; Testing conditions. If you want to see what happens with signal-all
;; change (signal condi) in controller to (signal-all condi)
;;
;; several items try to passa a condition which is signalled by an independent
;; process. Here you also see the uses of methods and functions together.

(define-class item named-object ())
(define-generic (procesa (anI item) condic))

;; the process for the items

(define-async-method (procesa (anI item) condic)               
   (let loop ()
     (displayLine (current-time) (item-name anI) ":wait at condition")
     (wait-for condic)
     (displayLine (current-time) (item-name anI) ":passed")
     (reset condic)
     (DisplayLine (current-time) (item-name anI)":semaphore to red")
      (loop)))

;; the code responsible for the signalling of the condition, with a fixed
;; interval of 2 units of time..

(define-async-function (controller condi)
   (let loop ()
     (DisplayLine (current-time) "semaphore to green")
     (signal condi)
     (wait-duration  2)
     (loop)))

;;;--------------------------------------------------------------------------
;;;                         Now simulate
;;;--------------------------------------------------------------------------

(let ((condi (instantiate condition))
      (p1 (instantiate item :name 'p1 ))
      (p2 (instantiate item :name 'p2 )))
  (reset condi)
  (init-simulation)
  (create-event 50 stop)
  (procesa p1 condi)
  (procesa p2 condi)
  (controller condi)
  (start-simulation))
