(define-class  body graphic-differential-Object
               ((= mass :maybe-uninitialized)
                (= force :initializer (make-point 0 0))))

(define-class system named-object
              ((= bodies :maybe-uninitialized)))

(define (fx aS) (<- (body-input aS) 0))
(define (fy aS) (<- (body-input aS) 1))
 
(define-method (velocity-map (aB body) x t)
    (let ((v (make-vector 4)))
      (-> v 0 (<- (body-state aB) 2))
      (-> v 1 (<- (body-state aB) 3))
      (-> v 2 (/ (fx aB) (body-mass aB)))
      (-> v 3 (/ (fy aB) (body-mass aB)))
      v))

   
(define (sqr x)(* x x))

;inputs are fx,fy



(define (make-system nb masses . posit&vels)
  (let ((aS (instantiate system  :bodies (make-bodies nb))))
    (for-each aS (lambda(x y)(set-body-mass! x y)) (system-bodies aS) masses)
    (for-each aS (lambda(x y)(set-body-state! x (list->vector y)))
              (system-bodies aS) posit&vels)
    aS))

(define (distance x y)
  (+ (sqr (- (<- (body-state x) 2)
             (<- (body-state y) 2)))
     (sqr (- (<- (body-state x) 3)
             (<- (body-state y) 3)))))

         

(define (all-distances system)
  (let loop ((xx (system-bodies system)) (d '()))
    (if (pair? xx)
      (loop (cdr xx)
            (cons (map (lambda(y)(distance (car xx) y)) (cdr xx)) d))
      d)))

(define (force bodya bodyb)
  (let* ((d (distance (bodya bodyb)))
         (factor (* (body-mass bodya)
                    (body-mass bodyb)
                    (1.0 / (expt d 1.5)))))
    (make-point (* (factor (- (<- (body-state x) 2)
                              (<- (body-state y) 2)))
                   (factor (- (<- (body-state x) 3)
                              (<- (body-state y) 3)))))))



  
              