;;;   S Y S T E M   T O O L B O X
;;;   = = = = = =   = = = = = = =
;;;
;;; System Dependent Toolbox
;;;
;;; This toolbox localizes those calls to routines that are specific
;;; to a particular implementation.
;;;

; The following is the most negative/positive fixnum. They are used
; for example as the value of a state in the search toolbox of
; little/great relevance.

(define NEG-INFINITY -268435456)
(define INFINITY     +268435456)

;; The following change is required due to the toolboxes treating the
;; empty list as identical to #f

(define (null? x) (cond ((##null? x) #t)
                        (x #f)
                        (else #t)))

; Error handling
; --------------
; All detected errors in the toolboxes call Fatal-Error with a
; message describing the error. If a routine named Error-Continuation
; has been defined it is called instead of the system debugger

(define Error-Continuation #f)

(define Fatal-Error
  (lambda aMessageList
    (display "TOOLBOX ERROR: ")
    (for-each (lambda (aMessage)
                (display " ")
                (display aMessage))
              aMessageList)
    (newline)
    (if Error-Continuation
          (Error-Continuation "ERROR-VALUE")
          (error "TOOLBOX ERROR: " #t))))

; Testing
; -------
; The following routines are only called in the testing routines so that
; it is not necessary that it be defined to use the toolbox. The
; functions 'eval' and 'pretty-print' are not part of standard R^3
; scheme but are available in many implementations.

(define EvalExp (lambda (anExp) (eval anExp)))

(define MyPrettyPrint (lambda (anExp) (pretty-print anExp)))

;;random numbers load at init time

