;;;SimmerInit
;====================================================================
;;if you use a different directory structure then you should modify this.

(define simmer-path     (string-append gambit-path "SimMerV1.01:"))
(define simul-path      (string-append simmer-path "simmerSources:"))
(define toolboxes-path  (string-append simmer-path "Toolboxes:"))
(define *terminator* ".scm")
(displayLine "SimmerV1.01  1 March 1996")
;====================================================================


;           DEFINITIONS for GLOBAL GENERIC FUNCTIONS
; These functions should be the basis for object passing among objects.
; They are not (yet) exploited in this version of SimMer. 
; But will probably be in future versions (if I ever get to producing them...)

(define-generic (take (unObjeto Object) x))
(define-generic (give (unObjeto Object) . args))
(define-generic (reset (unObjeto Object)))
(define-generic (setup (unObjeto Object)))
(define-generic (display-object (unObjeto Object) . port) (Show unObjeto))
(define-generic (display-object-list (unObject Object) . lista)
      (map Show (cons unObject lista)))

;; by default the key of an object is the object itself.
(define-generic (object-key (ao)) ao)
;; I just specialize object< for numeric keys. 
(define-generic (object<? (a1) (a2))
     (< (object-key a1) (object-key a2)))

;;; whenever a slot contains an object, we condider two possibilities:
;;; 1) The slot contains a statistis gathering object. In this case the user 
;;;    may initialize the slot at instantiation time to anything he wishes as 
;;;    long as it is a statistics gathering object,i.e. class stat-var
;;; 2) The slot contains another object. Normally the user should not 
;;;    initialize the slot. The system takes care of it and does not allow 
;;;    user fiddling with the system defaults.

;;; To comply with the above we normally assign objet slots in an initialize! 
;;; method. For non user unitialized object we perfomr a initialize-field-value!
;;; that bitterly complains if the field is already initialized.
;;; For user initiaslizable fields we check that the supplied object if any is 
;;; of the right kind, and if no object is supplied we create defaults.

;;; This last job is performed by the following function:

(define (init-stats-gatherer! ano what slot)
  (if (is-there-a-field-in? ano slot)
    (if (field-uninitialized? ano slot)
      (initialize-field-value! ano what slot)
      (if (and (object? (field-value ano slot))
               (is-a? (field-value ano slot) stat-var-class))
        #t
        (begin
          (show (field-value ano slot))
          (error "Invalid Object in gathering slot of " (get-name ano)))))
    (error "No such field in " (get-name ano) slot)))